import java.awt.Color;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;


public class Cell  extends JPanel {
	
	public int col=-1;
	public int row=-1;
	
	// pointer 
	public Cell cellbottom = null;
	public Cell cellright = null;
	public Cell cellbottomleft = null;
	public Cell cellbottomright = null;
	
	public Color backgroundColor = Color.WHITE; // white ==> no player cell
	
	public Cell(int row, int col) {
		this.col=col;
		this.row=row;
		setBackground(backgroundColor);
	  	TitledBorder tb = new TitledBorder( LineBorder.createBlackLineBorder());
	  	setBorder(tb);	
	  	add(new JLabel(Integer.toString(row*100+col))); // only for the tests
	}
	
	// only for the tests
	@Override
	public String toString() {
		return "row: "+row+"  col: "+col;
	}
	
	
	// method for tests and click 
	public void click(Color color) {
	   playgame(color);
	}  // click
	
	
	// check if the bottomCell is != null  AND  bottomCell is empty (color=WHITE)
	public void playgame(Color color) {
		System.out.println("game cell: row: "+row+"  col: "+col);
		if (cellbottom!=null) {
		     // now we are in row 0 to n-2
		     // check, if the bottom cell are empty
			if (cellbottom.backgroundColor==Color.WHITE) {
				cellbottom.click(color);
			}			
			else {
			    // the bottom cell has a player chip, have I an empty cell?
			   checkActuallCell(color);
			}
		}
		else {
			// now, we are in the last row!!
   		   checkActuallCell(color);		
		}
	}	// playGame
	
	
	private void checkActuallCell(Color color) {
		if (backgroundColor==Color.WHITE) {
			backgroundColor = color;
			setBackground(backgroundColor);
			System.out.println("   set cell with color: row: "+row+"  col: "+col);
		}
		else {
				Basis.ErrorMsgBox("The cell has a player chip\nrow: "+row+"  col: "+col, "Fehler");
		}
	}  // checkActuallCell
	
	private void addColor(NumbersPlayerChips numbers) {
		System.out.println("addColor: row:"+row+"   col:"+col);
		if (backgroundColor==Color.RED) 
			numbers.incRed();
		else if (backgroundColor==Color.BLUE) 
			numbers.incBlue();
		else if (backgroundColor==Color.WHITE) 
			numbers.incWhite();
		else Basis.ErrorMsgBox("Falscher else Fall, addColor", "Error");
	}
	
	// it start the Check
	// go recursive to the bottom and sum the colors red and blue
	// the tests run from bottom to the top !
	public NumbersPlayerChips checkVertical() {
		NumbersPlayerChips numbers;
		if (cellbottom!=null)
			numbers = cellbottom.checkVertical();
		else
			numbers = new NumbersPlayerChips(); // only if countRows=1 or at the bottom!!
		
		addColor(numbers);
		
		return numbers;
	}	
	
	
	// go recursive to the bottom and sum the horizontal colors red and blue
	// first: go horizontal recursive
	// second: go vertical
	// problem, not every cells should go vertical, only the first
	// the tests run from right to the left !
	public NumbersPlayerChips checkHorizontal(boolean firstColumn){
		NumbersPlayerChips numbers = new NumbersPlayerChips(); // for the bottom right cell
		// check MY row
		if (cellright!=null) {
			numbers = cellright.checkHorizontal(false);
			
			addColor(numbers);
			
			// MY row are "gameover" ?
			if (numbers.getRed()>=4 || numbers.getBlue()>=4) return numbers;
		}
		else {
			numbers = new NumbersPlayerChips(); // only if countCols=1 or right !!
			addColor(numbers);
			return numbers;
		}
		if (firstColumn && cellbottom!=null) {
			numbers = cellbottom.checkHorizontal(true);  // true because recursive !!!
			// here NOT add my color, it is the sum of the lower row !!
		}
		return numbers;
	}  // checkHorizontal
	
	
	
	
	// it start the first diagonal check
	// go recursive to the bottom/right and sum the colors red and blue
	// first: go diagonal recursive
	// second: go vertical to the next diagonal
	// problem, not every cells should go vertical, only the first/left
	// the tests run from bottom to the top !
	public NumbersPlayerChips checkDiagonals1(boolean firstColumn) {
		NumbersPlayerChips numbers = new NumbersPlayerChips(); // for the bottom right cell
		// check MY row
		if (cellbottomright!=null) {
			numbers = cellbottomright.checkDiagonals1(false);
			addColor(numbers);
			
			// MY diagonal row are "gameover" ?
			if (numbers.getRed()>=4 || numbers.getBlue()>=4) return numbers;
		}
		else {
			numbers = new NumbersPlayerChips(); 
			addColor(numbers);
			return numbers;
		}
		if (firstColumn && cellbottom!=null) {
			numbers = cellbottom.checkDiagonals1(true);  // true because recursive !!!
			// here NOT add my color, it is the sum of the lower row !!
		}
		return numbers;
	}

	
	
	// it start the second diagonal check
	// go recursive to the bottom/left and sum the colors red and blue
	// first: go diagonal recursive
	// second: go vertical to the next diagonal
	// problem, not every cells should go vertical, only the first/right
	// the tests run from bottom to the top !
	public NumbersPlayerChips checkDiagonals2(boolean firstColumn) {
		NumbersPlayerChips numbers = new NumbersPlayerChips(); 
		// check MY row
		if (cellbottomleft!=null) {
			numbers = cellbottomleft.checkDiagonals2(false);
			addColor(numbers);
			// MY diagonal row are "gameover" ?
			if (numbers.getRed()>=4 || numbers.getBlue()>=4) return numbers;
		}
		else {
			numbers = new NumbersPlayerChips(); 
			addColor(numbers);
			return numbers;
		}
		if (firstColumn && cellbottom!=null) {
			numbers = cellbottom.checkDiagonals2(true);  // true because recursive !!!
			// here: NOT add my color, it is the sum of the lower row !!
		}
		return numbers;
	}


}
